Attribute VB_Name = "Module2"
Option Explicit

Public Function WinP(ByVal H As Long, ByVal M As Long, _
                    ByVal Wp As Long, ByVal Lp As Long) As Long
    Suite H, M, Wp, Lp
    WinP = CallWindowProc(Proc, H, M, Wp, Lp)
End Function

Private Sub Suite(ByVal H As Long, ByVal M As Long, _
                ByVal Wp As Long, ByVal Lp As Long)
    Select Case M
        Case WM_MEASUREITEM
            Dim Struct As MEASUREITEMSTRUCT
                CopyMemory Struct, ByVal Lp, Len(Struct)
                Struct.ItemHeight = 21
                Struct.ItemWidth = 60
                CopyMemory ByVal Lp, Struct, Len(Struct)
        Case WM_DRAWITEM
                PopMenu (Lp)
    End Select
End Sub

Private Sub PopMenu(ByVal Lp As Long)

Dim Struct As DRAWITEMSTRUCT
Dim Selection As Long, Resultat As Long
Dim R As RECT
    CopyMemory Struct, ByVal Lp, Len(Struct)
    If Struct.CtlType = ODT_MENU Then
        Selection = ((Struct.itemState And ODS_SELECTED) = ODS_SELECTED)
        Resultat = SetBkMode(Struct.Hdc, TRANSPARENT)
            If Selection Then
                Menu_Selectionne (Lp)
            Else
                Menu_Non_Selectionne (Lp)
            End If
    Resultat = ImageList_Draw(ImageH, 0, Struct.Hdc, Struct.rcItem.Left + 2, Struct.rcItem.Top + 2, ILD_TRANSPARENT)
        
        R.Left = Struct.rcItem.Left + 25
        R.Top = Struct.rcItem.Top + 3
        R.Bottom = Struct.rcItem.Top + 21
        R.Right = Struct.rcItem.Right
        
        Resultat = DrawText(Struct.Hdc, "Quitter", Len("Quitter"), R, DT_LEFT)
    End If
End Sub

Private Sub Menu_Selectionne(ByVal Lp As Long)

Dim Struct As DRAWITEMSTRUCT, R As RECT
Dim Hbrush As Long, Resultat As Long, Sel As Long
Dim HBureau As Long, DcBureau As Long, CompatDC As Long
Dim CompBmp As Long

    CopyMemory Struct, ByVal Lp, Len(Struct)
    Resultat = ReleaseDC(HBureau, DcBureau)
    Hbrush = CreateSolidBrush(GetSysColor(COLOR_MENUTEXT))

    R.Bottom = Struct.rcItem.Bottom
    R.Right = Struct.rcItem.Right
    R.Left = 22

    Resultat = FillRect(Struct.Hdc, R, Hbrush)
    Resultat = DeleteObject(Hbrush)
    Resultat = SetTextColor(Struct.Hdc, GetSysColor(COLOR_3DLIGHT))
                
    R.Left = Struct.rcItem.Left
    R.Top = Struct.rcItem.Top
    R.Bottom = 21
    R.Right = 21
    
    Resultat = DrawEdge(Struct.Hdc, R, BDR_RAISEDINNER, BF_RECT)
End Sub

Private Sub Menu_Non_Selectionne(ByVal Lp As Long)

Dim Struct As DRAWITEMSTRUCT, R As RECT
Dim Hpen As Long, Resultat As Long, Hbrush As Long
Dim Sel As Long
    CopyMemory Struct, ByVal Lp, Len(Struct)
    Hpen = CreatePen(0, 1, GetSysColor(COLOR_MENU))
    Hbrush = CreateSolidBrush(GetSysColor(COLOR_MENU))
    
    Sel = SelectObject(Struct.Hdc, Hpen)
    Sel = SelectObject(Struct.Hdc, Hbrush)
    
    R.Left = Struct.rcItem.Left
    R.Top = Struct.rcItem.Top
    R.Bottom = Struct.rcItem.Bottom
    R.Right = Struct.rcItem.Right
    
    Resultat = Rectangle(Struct.Hdc, R.Left, R.Top, R.Right, R.Bottom)
    
    Resultat = DeleteObject(Hpen)
    Resultat = DeleteObject(Hbrush)
End Sub
